﻿package
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	
	public class BarreOutils extends Sprite 
	{
		public var progresse:ProgresseTime;
		public var son:SliderSon;
		
		private var boutonPlay:BoutonPlayVideo;		// le bouton play qui se trouve dans la bibliothèque
		private var boutonPause:BoutonPauseVideo;	// le bouton pause
		private var boutonStop:BoutonStopVideo;		// stop
		private var boutonFullScreen:BoutonFullscreenVideo;
		
		public var pauseOuPlay:Boolean = true;
		public var boutons:Sprite;
		public var droite:Sprite;
		
		public function BarreOutils():void
		{
			this.boutons = new Sprite();
			this.addChild(this.boutons);
			this.droite  = new Sprite();
			this.addChild(this.droite);
			
			this.gestionChidren();
		}
		
		public function toogleBoutonPause()
		{
			if( this.pauseOuPlay ) {
				this.afficheBoutonPlay();
			}
			else
			{
				this.boutons.addChild(this.boutonPause);
				this.boutonPause.addEventListener( MouseEvent.MOUSE_UP, pauser );
				this.boutons.removeChild(this.boutonPlay);
				this.boutonPlay.removeEventListener( MouseEvent.MOUSE_UP, jouer );
				this.pauseOuPlay = true;
			}
		}
		
		public function afficheBoutonPlay()
		{
			if( this.pauseOuPlay )
			{
				this.boutons.removeChild(this.boutonPause);
				this.boutonPause.removeEventListener( MouseEvent.MOUSE_UP, pauser );
				this.boutons.addChild(this.boutonPlay);
				this.boutonPlay.addEventListener( MouseEvent.MOUSE_UP, jouer );
				this.pauseOuPlay = false;
			}
		}
		
		private function gestionChidren():void
		{
			this.boutonStop = new BoutonStopVideo();
			this.boutonStop.buttonMode = true;
			this.boutonStop.x = 20;
			this.boutonStop.addEventListener( MouseEvent.MOUSE_UP, stopper );
			this.boutons.addChild(this.boutonStop);
			
			this.boutonPlay = new BoutonPlayVideo();
			this.boutonPlay.buttonMode = true;
			this.boutonPlay.x = 50;
			this.boutonPlay.addEventListener( MouseEvent.MOUSE_UP, jouer );
			
			this.boutonPause = new BoutonPauseVideo();
			this.boutonPause.buttonMode = true;
			this.boutonPause.x = 50;
			this.boutonPause.addEventListener( MouseEvent.MOUSE_UP, pauser );
			this.boutons.addChild(this.boutonPause);
			
			// BARRE DE PROGRESSION
			this.progresse = new ProgresseTime();
			this.progresse.y = -10;
			this.addChild(this.progresse);
			
			this.boutonFullScreen = new BoutonFullscreenVideo();
			this.boutonFullScreen.buttonMode = true;
			this.boutonFullScreen.x = LecteurVideo.LARGEUR - SliderSon.PADDING_X;
			this.boutonFullScreen.addEventListener( MouseEvent.MOUSE_UP, fullscreen );
			this.droite.addChild(this.boutonFullScreen);
			
			// SON
			this.son = new SliderSon( 40, 20 );
			this.son.x = this.boutonFullScreen.x - this.boutonFullScreen.width;
			this.son.y = SliderSon.PADDING_Y;
			this.droite.addChild(this.son);
			
			this.initialise();
		}
		
		public function initialise():void
		{
			this.progresse.x = this.boutons.width + ProgresseTime.PADDING_X;
			// recalcule la taille de la barre
			ProgresseTime.LARGEUR = LecteurVideo.LARGEUR - this.progresse.x - this.droite.width;
			this.progresse.recalcul();
		}
		
		private function stopper( e:MouseEvent ):void {
			dispatchEvent(new BarreOutilsEvent(BarreOutilsEvent.BOUTON_STOP));
		}
		
		private function jouer( e:MouseEvent ):void {
			dispatchEvent(new BarreOutilsEvent(BarreOutilsEvent.BOUTON_PLAY));
		}
		
		private function pauser( e:MouseEvent ):void {
			dispatchEvent(new BarreOutilsEvent(BarreOutilsEvent.BOUTON_PAUSE));
		}
		
		private function fullscreen( e:MouseEvent ):void{
			dispatchEvent(new BarreOutilsEvent(BarreOutilsEvent.BOUTON_FULLSCREEN));
		}
	}
}