﻿package
{
	/*
		Cette classe sert (bien sûr) à gérer automatiquement le lecteur vidéo.
		Mais pour l'appliquer correctement il faut évidement faire quelques lignes de code, comme vous pouvez le voir dans Application.as
	*/
	
	import flash.display.StageDisplayState;
	import flash.display.StageScaleMode;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.events.NetStatusEvent;
	import flash.events.AsyncErrorEvent;
	import flash.events.FullScreenEvent;
	import flash.media.Video;
	import flash.net.NetConnection;
	import flash.net.NetStream;
	import flash.media.SoundTransform;
	import flash.text.TextField;
	
	public class LecteurVideo extends Sprite 
	{
		private var videoURL:String;								// L'url de la vidéo à lire
		private var connection:NetConnection;				// le netconnection (un truc flash, faut pas chercher)
		private var flux:NetStream;									// le netstream (comme le netconnection : faut pas chercher)
		private var conteneurVideo:Sprite;					// le conteneur de tout le block vidéo
		private var conteneurVideoSimple:Sprite;		// le conteneur de la vidéo seulement
		private var maVideo:Video;									// et la variable POUR la video
		private var barre:BarreOutils;
		private var barreScene:Sprite;
		private var boutonStart:StartPlay;
		private var s:SliderSon;
		private var videoWidth:uint;
		private var videoHeight:uint;
		private var videoX:Number;
		private var videoY:Number;
		private var radioVideo:Number;
		private var fullScreen:Boolean = false;
		private var image:ChargerFond;
		
		public static const HAUTEUR:uint = 320;
		public static const LARGEUR:uint = 480;
		
		// Si l'utilisateur à lui même mis en pause
		private var pauseManuel:Boolean = false;
		
		public function LecteurVideo( url:String, urlImg:String ):void
		{
			// on récupère le paramètre url, pour retenir l'url de la vidéo
			this.videoURL = url;
			// on instancie les conteneurs
			this.conteneurVideoSimple = new Sprite();
			this.conteneurVideo = new Sprite();
			this.addChild(conteneurVideo);
			
			// barre d'outils
			this.barre = new BarreOutils();
			// barre d'outils sur la video
			this.barreScene = new Sprite();
			this.barreScene.addChild(barre);
			this.conteneurVideo.addChild(barreScene);
			this.initializeBarre();
			
			// bouton de démarrage du lecteur
			this.boutonStart = new StartPlay();
			this.boutonStart.addEventListener( MouseEvent.CLICK, startVideo );
			this.conteneurVideo.addChild(boutonStart);
			this.boutonStart.x = 200;
			this.boutonStart.y = 100;
			
			// charge l'image de fond :p
			this.image = new ChargerFond(urlImg);
			this.conteneurVideo.addChildAt( this.image, 0 );
		}
		
		private function initializeBarre():void
		{
			this.barreScene.y = LecteurVideo.HAUTEUR - this.barre.height / 2;
			this.barre.boutons.x = 0;
			this.barre.droite.x = 0;
			this.barre.initialise();
		}
		
		private function startVideo( e:MouseEvent )
		{
			this.conteneurVideo.removeChild(this.boutonStart);
			this.conteneurVideo.removeChild(this.image);
			this.boutonStart.removeEventListener( MouseEvent.CLICK, startVideo );
			
			this.connectConfig();
		}
		
		private function connectConfig():void
		{
			// on configure le NetConnection
			connection = new NetConnection();
			connection.addEventListener( NetStatusEvent.NET_STATUS, netStatusHandler );
			connection.connect(null);
		}
    
		private function netStatusHandler( e:NetStatusEvent ):void
		{
    	switch( e.info.code )
			{
      	case "NetConnection.Connect.Success":
        	this.connectFlux();
        break;
        case "NetStream.Play.StreamNotFound":
					var info:TextField = new TextField();
					info.x = 200;
					info.y = 100;
					info.text = "Unable to locate video: " + videoURL;
					this.addChild(info);
        break;
    	}
    }
		
		/*
			La fonction compliquer qui permet de récupérer la vidéo en streaming et de la diffuser
		*/
		private function connectFlux():void 
		{
			// on connect le flux, on se met en symbiose
			flux = new NetStream(connection);
			flux.addEventListener( AsyncErrorEvent.ASYNC_ERROR, asyncErrorHandler );
			flux.addEventListener( NetStatusEvent.NET_STATUS, netStatusHandler );
			flux.bufferTime = 2;
			// on créer l'objet vidéo et la place avec une taille
			maVideo = new Video();
			// on ajoute la video dans le conteneur de la vidéo
			conteneurVideoSimple.addChild(maVideo);
			// on met le conteneur de la vidéo dans cette principal du lecteur vidéo
			conteneurVideo.addChildAt( conteneurVideoSimple, 0 );
			// on continue la symbiose avec Video()
			maVideo.attachNetStream(flux);
			// taille
			this.radioVideo = maVideo.width / maVideo.height;
			this.resizeVideo();
			// gère le temps de video
			var customClient:Object = new Object();
      customClient.onMetaData = function( infoObject:Object )
			{
        barre.progresse.timeMax = infoObject.duration;
				configFlux();
			};
      flux.client = customClient;
			flux.play(videoURL);
		}
		
		private function resizeVideo():void
		{
			if( this.videoWidth > 0 && this.videoHeight > 0 )
			{
				maVideo.width  = this.videoWidth;
				maVideo.height = this.videoHeight;
				maVideo.x  		 = this.videoX;
				maVideo.y      = this.videoY;
			}
			else
			{
				var hauteur = stage.stageWidth / this.radioVideo;
				if( hauteur > stage.stageHeight )
				{
					maVideo.height = this.videoHeight = stage.stageHeight;
					maVideo.width  = this.videoWidth  = maVideo.height * this.radioVideo;
					maVideo.x = this.videoX = (stage.stageWidth - maVideo.width) / 2;
				}
				else
				{
					maVideo.width  = this.videoWidth  = stage.stageWidth;
					maVideo.height = this.videoHeight = maVideo.width / this.radioVideo;
					maVideo.y = this.videoY = (stage.stageHeight - maVideo.height) / 2;
				}
			}
		}
		
		private function configFlux():void
		{
			this.barre.progresse.poidsMax = this.flux.bytesTotal;
			// affiche le slider de temps
			this.conteneurVideoSimple.addEventListener( Event.ENTER_FRAME, navigateurTemps );
			// gestion du chargement de la video
			this.conteneurVideoSimple.addEventListener( Event.ENTER_FRAME, chargementVideo );
			// le Son
			this.barre.son.addEventListener( SliderSonEvent.VALUE_CHANGED, modifSon );
			// intègre maintenant l'interface video
			this.interfaceVideo();
		}
		
		public function modifSon( e:SliderSonEvent ):void
		{
			var transformation:SoundTransform = this.flux.soundTransform;
			// on régle le son
			//flux.soundTransform.volume = s.son;
			transformation.volume = this.barre.son.niveau;
			this.flux.soundTransform = transformation;
		}
		
		/*
			On s'occupe purement de l'interface du lecteur, cadre et boutons
		*/
		private function interfaceVideo():void 
		{
			barre.addEventListener( BarreOutilsEvent.BOUTON_PLAY,  jouer );
			barre.addEventListener( BarreOutilsEvent.BOUTON_PAUSE, pauser );
			barre.addEventListener( BarreOutilsEvent.BOUTON_STOP,  stopper );
			barre.addEventListener( BarreOutilsEvent.BOUTON_FULLSCREEN, jouerAvecEcran );
			stage.addEventListener( FullScreenEvent.FULL_SCREEN, jouerAvecEcran );
			
			barre.addEventListener( ProgresseTimeEvent.AQUIS, changeTime );
			// active l'interactivite de la barre de progression
			barre.progresse.active = true;
		}
		
		private function changeTime( e:ProgresseTimeEvent ):void
		{
			barre.afficheBoutonPlay();
			flux.pause();
			barre.progresse.addEventListener( ProgresseTimeEvent.AVANCE, avancer );
			barre.progresse.addEventListener( ProgresseTimeEvent.DEFINI, avancerFini );
		}
		
		private function avancerFini( e:ProgresseTimeEvent ):void
		{
			if( !this.pauseManuel )
			{
				barre.toogleBoutonPause();
				flux.togglePause();
			}
			barre.progresse.removeEventListener( ProgresseTimeEvent.AVANCE, avancer );
			barre.progresse.removeEventListener( ProgresseTimeEvent.DEFINI, avancerFini );
			conteneurVideoSimple.addEventListener( Event.ENTER_FRAME, navigateurTemps );
		}
		
		// -------------------------------------
		// Gère l'avancement de la video par le curseur
		private function avancer( e:ProgresseTimeEvent ):void
		{
			// quand on bouge le curseur on stop l'évenement
			conteneurVideoSimple.removeEventListener( Event.ENTER_FRAME, navigateurTemps );
			// si la valeur est bonne on change le temps de la video
			if( e.valeur <= barre.progresse.timeMax ) {
				flux.seek(e.valeur);
			}
			// sinon c'est qu'il y a un problème et on stop la video
			else this.stopVideo();
		}
		
		// -------------------------------------
		// Chargement en stream de la vidéo
		private function chargementVideo( e:Event ):void
		{
			// nombre de bytes charger
			barre.progresse.poids = flux.bytesLoaded;
			// si on est au fond, on coupe le chargement
			if( barre.progresse.poidsMax > 0 && barre.progresse.poidsMax <= flux.bytesLoaded )
				conteneurVideoSimple.removeEventListener( Event.ENTER_FRAME, chargementVideo );
		}
		
		// -------------------------------------
		// Gère le slider/scroll de navigation dans le temps
		private function navigateurTemps( e:Event ):void
		{
			// met à jour le temps courant de la video
			this.barre.progresse.time = this.flux.time;
			this.barre.progresse.scroll();
			// si on est trop loin
			if( this.flux.time >= this.barre.progresse.timeMax )
				this.stopVideo();
			
			trace(this.flux.currentFPS);
			//trace( barre.progresse.minute + ':' + barre.progresse.seconde + ' / ' + barre.progresse.minuteTotal + ':' + barre.progresse.secondeTotal );
		}
		
		// -------------------------------------
		// OSEF MAIS OBLIGE :(
		private function asyncErrorHandler( e:AsyncErrorEvent ):void {}
		
		private function stopper( e:BarreOutilsEvent ):void
		{
			this.stopVideo();
		}
		
		private function pauser( e:BarreOutilsEvent ):void
		{
			this.flux.pause();
			this.barre.toogleBoutonPause();
			this.pauseManuel = true;
			
			conteneurVideoSimple.removeEventListener( Event.ENTER_FRAME, navigateurTemps );
		}
		
		private function jouer( e:BarreOutilsEvent ):void
		{
			this.flux.togglePause();
			this.barre.toogleBoutonPause();
			this.pauseManuel = false;
			
			conteneurVideoSimple.addEventListener( Event.ENTER_FRAME, navigateurTemps );
		}
		
		private function stopVideo():void
		{
			this.flux.seek(0);
			this.flux.pause();
			this.barre.afficheBoutonPlay();
		}
		
		/*
			Met le pleine écran
		*/
		private function jouerAvecEcran( e:Event ):void
		{
			if( this.fullScreen )
			{
				// et on met etatEcranPlein à faux pour l'indiquer au programme
				stage.displayState = StageDisplayState.NORMAL;
				this.fullScreen = false;
				// RESIZE
				this.resizeVideo();
				this.initializeBarre();
			}
			else
			{
				// sinon on met la vidéo en plein écran
				// et on l'indique à etatEcranPlein
				stage.displayState = StageDisplayState.FULL_SCREEN;
   			stage.scaleMode = StageScaleMode.NO_SCALE;
				this.fullScreen = true;
				stage.addChild(this.conteneurVideo);
				
				var hauteur = stage.fullScreenWidth / this.radioVideo;
				if( hauteur > stage.fullScreenHeight )
				{
					this.maVideo.height = stage.fullScreenHeight;
					this.maVideo.width  = this.maVideo.height * this.radioVideo;
					this.maVideo.y = -(stage.fullScreenHeight - LecteurVideo.HAUTEUR) / 2;
					this.maVideo.x = -(stage.fullScreenWidth - LecteurVideo.LARGEUR) / 2 + (stage.fullScreenWidth - this.maVideo.width) / 2;
				}
				else
				{
					this.maVideo.width  = stage.fullScreenWidth;
					this.maVideo.height = this.maVideo.width / this.radioVideo;
					this.maVideo.y = -(stage.fullScreenHeight - LecteurVideo.HAUTEUR) / 2 + (stage.fullScreenHeight - this.maVideo.height) / 2;
					this.maVideo.x = -(stage.fullScreenWidth - LecteurVideo.LARGEUR) / 2;
				}
				
				var paddingX:uint = this.barre.boutons.width + 20;
				
				this.barreScene.y = (stage.fullScreenHeight + LecteurVideo.HAUTEUR - this.barre.height) / 2;
				this.barre.boutons.x = -(stage.fullScreenWidth - LecteurVideo.LARGEUR) / 2;
				this.barre.progresse.x = this.barre.boutons.x + paddingX;
				
				ProgresseTime.LARGEUR = stage.fullScreenWidth - paddingX - this.barre.droite.width;
				this.barre.droite.x = -this.barre.boutons.x;
				this.barre.progresse.recalcul();
			}
		}
	}
}