﻿package
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	
	public class ProgresseTime extends Sprite 
	{
		private var barre:Sprite = new Sprite();
		private var masque:Sprite = new Sprite();
		private var chargementVideo:Sprite = new Sprite();
		
		private var _timeMax:Number;
		private var _time:Number;
		private var _minute:String  = '00';
		private var _seconde:String = '00';
		private var _poidsMax:uint;
		private var _poids:uint;
		private var souris:uint;
		
		public static var LARGEUR:uint = 300;
		public static var HAUTEUR:uint = 15;
		public static var PADDING_X:uint = 20;
		
		public function ProgresseTime():void
		{
			// calcul les tailles
			this.recalcul();
			// barre de progression charger
			this.chargementVideo.x = this.chargementVideo.y = 1;
			// barre de progression en chargement
			this.addChild(this.masque);
			// masque
			this.addChild(this.barre);
			this.barre.mask = this.masque;
		}
		
		public function recalcul():void
		{
			var largeurTotal:uint = ProgresseTime.LARGEUR + 2;
			var hauteurTotal:uint = ProgresseTime.HAUTEUR + 2;
			// fond
			this.graphics.clear();
			this.graphics.beginFill( 0x000000, 0 );
			this.graphics.lineStyle( 1, 0xFFFFFF );
			this.graphics.lineTo( largeurTotal, 0 );
			this.graphics.lineTo( largeurTotal, hauteurTotal );
			this.graphics.lineTo( 0, hauteurTotal );
			this.graphics.lineTo( 0, 0 );
			// barre de progression charger
			this.chargementVideo.graphics.clear();
			this.chargementVideo.graphics.beginFill( 0x00FF00 );
			this.chargementVideo.graphics.drawRect( 0, 0, 1, ProgresseTime.HAUTEUR );
			// barre de progression en chargement
			this.masque.graphics.clear();
			this.masque.graphics.beginFill(0x0000FF);
			this.masque.graphics.drawRect( 1, 0, ProgresseTime.LARGEUR, hauteurTotal );
			// masque
			this.barre.graphics.clear();
			this.barre.graphics.beginFill(0xFF0000);
			this.barre.graphics.drawRect( 0, 1, ProgresseTime.LARGEUR, ProgresseTime.HAUTEUR );
			
			if( this._timeMax > 0 && this.souris > 0 ) this.scroll();
			else this.barre.x = -ProgresseTime.LARGEUR;
			
			this.updateChagement();
		}
		
		public function set active( val:Boolean ):void
		{
			if( val )
			{
				// permet le bouger la barre
				this.addEventListener( MouseEvent.MOUSE_DOWN, beginDragVol );
				// active l'effet bouton
				this.buttonMode = true;
				// integre la barre de chargement
				this.addChildAt( this.chargementVideo, 0 );
			}
			else
			{
				this.removeEventListener( MouseEvent.MOUSE_DOWN, beginDragVol );
				this.buttonMode = false;
			}
		}
		
		private function beginDragVol( e:MouseEvent ):void
		{
			dispatchEvent(new ProgresseTimeEvent( ProgresseTimeEvent.AQUIS, this.souris ));
			
			var sourisX:uint = e.stageX - this.x;
			this.barre.x = sourisX - ProgresseTime.LARGEUR;
			this.souris = sourisX / ProgresseTime.LARGEUR * this._timeMax;
			dispatchEvent(new ProgresseTimeEvent( ProgresseTimeEvent.AVANCE, this.souris ));
					
			this.addEventListener( MouseEvent.MOUSE_MOVE, avance );
			this.addEventListener( MouseEvent.MOUSE_UP, endDragVol );
    }
		
		private function avance( e:MouseEvent ):void
		{
			var sourisX:uint = e.stageX - this.x;
			
			if( sourisX <= ProgresseTime.LARGEUR )
				this.barre.x = sourisX - ProgresseTime.LARGEUR;
			
			this.souris = sourisX / ProgresseTime.LARGEUR * this._timeMax;
			dispatchEvent(new ProgresseTimeEvent( ProgresseTimeEvent.AVANCE, this.souris ));
		}
		
		private function endDragVol( e:MouseEvent ):void
		{
	    this.removeEventListener( MouseEvent.MOUSE_MOVE, avance );
			dispatchEvent(new ProgresseTimeEvent(ProgresseTimeEvent.DEFINI));
		}
		
		public function scroll():void
		{
			this.barre.x = ProgresseTime.LARGEUR * this._time / this._timeMax - ProgresseTime.LARGEUR;
		}
		
		public function set timeMax( val:Number ):void
		{
			this._timeMax = val;
		}
		
		public function get timeMax():Number
		{
			return this._timeMax;
		}
		
		public function set poidsMax( val:uint ):void
		{
			this._poidsMax = Math.round(val);
			
			var minute:uint = this._timeMax / 60;
			this._minute = ( minute > 10 )? minute.toString() : '0' + minute.toString();
			
			var seconde:uint = this._timeMax % 60;
			this._seconde = ( seconde > 10 )? seconde.toString() : '0' + seconde.toString();
		}
		
		public function get poidsMax():uint
		{
			return this._poidsMax;
		}
		
		public function get minuteTotal():String
		{
			return this._minute;
		}
		
		public function get secondeTotal():String
		{
			return this._seconde;
		}
		
		public function set time( val:uint ):void
		{
			this._time = val;
		}
		
		public function set poids( val:uint ):void
		{
			this._poids = val;
			this.updateChagement();
		}
		
		private function updateChagement():void
		{
			if( this._poidsMax > 0 && this.chargementVideo.scaleX != ProgresseTime.LARGEUR && this.chargementVideo.scaleX <= ProgresseTime.LARGEUR )
			{
				this.chargementVideo.scaleX = this._poids * ProgresseTime.LARGEUR / this._poidsMax;
			}
			// enleve si aucun intérêt
			if( this.chargementVideo.scaleX >= ProgresseTime.LARGEUR && this.contains(this.chargementVideo) )
			{
				this.removeChild(this.chargementVideo);
			} 
		}
		
		public function get minute():String
		{
			var minute:uint = this._time / 60;
			return ( minute > 10 )? minute.toString() : '0' + minute.toString();
		}
		
		public function get seconde():String
		{
			var seconde:uint = this._time % 60;
			return ( seconde > 10 )? seconde.toString() : '0' + seconde.toString();
		}
	}
}