﻿package
{
	/*
		Cette classe sert (bien sûr) à gérer automatiquement le lecteur vidéo.
		Mais pour l'appliquer correctement il faut évidement faire quelques lignes de code, comme vous pouvez le voir dans Application.as
	*/
	
	import flash.display.Sprite;
	//import flash.display.MovieClip;
	import flash.geom.Point;
	import flash.events.MouseEvent;
	
	public class SliderSon extends Sprite 
	{
		private var slider:Sprite = new Sprite();
		private var masque:Sprite = new Sprite();
		private var fond:Sprite = new Sprite();
		
		private var _niveau:Number = 0.5;
		
		public static const PADDING_X = 20;
		public static const PADDING_Y = 10;
		
		public function SliderSon( largeur:int, hauteur:int ):void
		{
			this.slider.graphics.beginFill(0x5555FF);
			this.slider.graphics.drawRect( 0, 0, -largeur, -hauteur );
			this.slider.x = -SliderSon.PADDING_X;
			
			this.graphics.beginFill( 0x00FF00, 0 );
			this.graphics.drawRect( SliderSon.PADDING_X, SliderSon.PADDING_Y, -( largeur + SliderSon.PADDING_X * 2 ), -( hauteur + SliderSon.PADDING_Y * 2 ) );
			
			this.addChild(slider);
			
			var point1:Point = new Point(0, 0);
			var point2:Point = new Point(-largeur, 0);
			var point3:Point = new Point(0, -hauteur);
			
			var verticies:Vector.<Number> = Vector.<Number>([point1.x, point1.y, point2.x, point2.y, point3.x, point3.y]);
			
			this.masque.graphics.beginFill(0xFF0000);
			this.masque.graphics.drawTriangles(verticies);
			addChild(this.masque);
			
			this.slider.mask = this.masque;
			
			this.fond.graphics.beginFill( 0x0000FF, 0.7 );
			this.fond.graphics.drawTriangles(verticies);
			this.addChildAt( this.fond, 0 );
			
			this.addEventListener( MouseEvent.MOUSE_DOWN, beginDragVol );
		}
		
		private function beginDragVol( e:MouseEvent ):void
		{
    	this.addEventListener( MouseEvent.MOUSE_MOVE, addListenerMove );
      this.addEventListener( MouseEvent.MOUSE_UP, endDragVol ); 
    }
		
		private function addListenerMove( e:MouseEvent ):void
		{
		  var souris:int = e.stageX - this.x;
			
			if( 0 >= souris && souris >= -40 )
			{
				this.slider.x = souris;
				
				this._niveau = slider.x / slider.width + 1;
				dispatchEvent(new SliderSonEvent(SliderSonEvent.VALUE_CHANGED));
			}             
		}
		
		private function endDragVol( e:MouseEvent ):void
		{
	    this.removeEventListener( MouseEvent.MOUSE_MOVE, addListenerMove );
		}
		
		public function get niveau():Number
		{
			return this._niveau;
		}
	}
}